unit Hrac1;

interface
  uses Deklar;

  procedure Init(Kolkaty: integer);
  procedure Tah(var Hraci: THraci; var MojTah: TSmer);

implementation

const minlongint:longint=-2147483647;
var dl,dlk,p,vysl,maxtest,ho,dol,vp,vl:longint;

procedure Init(Kolkaty: integer);
begin
  maxtest:=15;
end;

procedure rataj(co,i:longint);
  begin
    if co=jedlo then inc(vysl,10000000 div (sqr(i-1)*4+1))
    else if co<>nic then dec(vysl,304857*Dl div (sqr(i-1)*6+1));
  end;

function testujhore(x,y:longint):longint;
  var i,xx,yy:longint;
  begin
    vysl:=0;
    rataj(getp^[x,y-1],1);

    i:=1;
    while (i<maxtest) and (getp^[x,y-i] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*1000*i);
    i:=1;
    while (i<maxtest) and (getp^[x+1,y-i] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);
    i:=1;
    while (i<maxtest) and (getp^[x-1,y-i] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);

    for i:=2 to maxtest do
      begin
        for yy:=y-1 downto y-i do
            rataj(getp^[x-i+1,yy],i);
        for xx:=x-i+2 to x+i-2 do
            rataj(getp^[xx,y-i],i);
        for yy:=y-i to y-1 do
            rataj(getp^[x+i-1,yy],i);
      end;
    testujhore:=vysl;
  end;

function testujdole(x,y:longint):longint;
  var i,xx,yy:longint;
  begin
    vysl:=0;
    rataj(getp^[x,y+1],1);

    i:=1;
    while (i<maxtest) and (getp^[x,y+i] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*1000*i);
    i:=1;
    while (i<maxtest) and (getp^[x+1,y+i] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);
    i:=1;
    while (i<maxtest) and (getp^[x-1,y+i] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);

    for i:=2 to maxtest do
      begin
        for yy:=y+1 to y+i do
            rataj(getp^[x-i+1,yy],i);
        for xx:=x-i+2 to x+i-2 do
            rataj(getp^[xx,y+i],i);
        for yy:=y+i to y+1 do
            rataj(getp^[x+i-1,yy],i);
      end;
    testujdole:=vysl;
  end;

function testujvpravo(x,y:longint):longint;
  var i,xx,yy:longint;
  begin
    vysl:=0;
    rataj(getp^[x+1,y],1);

    i:=1;
    while (i<maxtest) and (getp^[x+i,y] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*1000*i);
    i:=1;
    while (i<maxtest) and (getp^[x+i,y+1] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);
    i:=1;
    while (i<maxtest) and (getp^[x+i,y-1] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);

    for i:=2 to maxtest do
      begin
        for xx:=x+1 to x+i do
            rataj(getp^[xx,y-i+1],i);
        for yy:=y-i+2 to y+i-2 do
            rataj(getp^[x+i,yy],i);
        for xx:=x+1 to x+i do
            rataj(getp^[xx,y+i-1],i);
      end;
    testujvpravo:=vysl;
  end;

function testujvlavo(x,y:longint):longint;
  var i,xx,yy:longint;
  begin
    vysl:=0;
    rataj(getp^[x-1,y],1);

    i:=1;
    while (i<maxtest) and (getp^[x-i,y] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*1000*i);
    i:=1;
    while (i<maxtest) and (getp^[x-i,y+1] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);
    i:=1;
    while (i<maxtest) and (getp^[x-i,y-1] in [jedlo,nic]) do inc(i);
    if dl>250 then dlk:=250
              else dlk:=dl;
    inc(vysl,dlk*dlk*300*i);

    for i:=2 to maxtest do
      begin
        for xx:=x-1 downto x-i do
            rataj(getp^[xx,y-i+1],i);
        for yy:=y-i+2 to y+i-2 do
            rataj(getp^[x-i,yy],i);
        for xx:=x-1 to x-i do
            rataj(getp^[xx,y-i+1],i);
      end;
    testujvlavo:=vysl;
  end;

procedure Tah(var Hraci: THraci; var MojTah: TSmer);
label 1;
begin
  with Hraci[1] do begin
    dl:=dlzka;
    ho:=minlongint;dol:=ho;vp:=ho;vl:=ho;
    if PoslTah<>3 then ho:=testujhore(x,y);
    if PoslTah<>1 then dol:=testujdole(x,y);
    if PoslTah<>2 then vp:=testujvpravo(x,y);
    if PoslTah<>0 then vl:=testujvlavo(x,y);
    if (ho>=dol) and (ho>=vp) and (ho>=vl) then begin Mojtah:=1;goto 1;end;
    if (dol>=ho) and (dol>=vp) and (dol>=vl) then begin Mojtah:=3;goto 1;end;
    if (vp>=dol) and (vp>=ho) and (vp>=vl) then begin Mojtah:=0;goto 1;end;
    Mojtah:=2;

1:        {POISTKA}
    p:=0;
    while (not (GetP^[x+PosX[MojTah],y+PosY[MojTah]] in [Jedlo,nic])) do begin
      MojTah:=(MojTah+1) and 3;
      inc(p);
      if p>4 then exit;
    end;
  end;
end;

end.