{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,R-,S+,V+,X-}
{$M 16384,65200,65200}

program Wurmi;
uses Graph,Crt,Dos,Deklar,Hrac1,Hrac2,Hrac3,Hrac4,Hrac5,Hrac6,Hrac7;
const Meno: array[1..PocHracov] of string[9] =
        ('Erikine  ','Zuzkine  ','Monikine ','Mirove   ','Igorove  ','Miskove  ','Andyho   ');
var Hraci: THraci;
    Init: array[1..PocHracov] of InitProc;
    Tah : array[1..PocHracov] of TahProc;
    Poradie: array[1..PocHracov] of integer;
    Max    : array[1..PocHracov] of integer;
    Mrtvych,ZostaloJedla,PocTahov: integer;
    Hr,Hra, PocHier: integer;
    MaxPocTahov: longint;
    h,m,s,s100: word;
    Smer: TSmer;


{$L EGAVGA.OBJ}
Procedure EGAVGADriver; External;

{$L TRIPFONT.OBJ}
Procedure TRIPFont; External;

procedure InitMain;
var Gd,Gm,i: integer;
const  MyPalette: PaletteType =
      (size: 15 ; Colors: (0,46,54,11,36,61,26,63,7,24,3,11,12,13,14,63) );

begin
  If RegisterBGIDriver(@EGAVGADriver)<0 Then {};
  If RegisterBGIFont(@TRIPFont)<0 Then {};
  ClrScr;
  write('Na kolko kol? '); readln(PocHier);
  write('Kolko tahov? '); readln(MaxPocTahov);
  Randomize;
  Gd:=Ega;Gm:=EgaHi;InitGraph(Gd,Gm,'');
  Init[1]:=Hrac1.Init;
  Init[2]:=Hrac2.Init;
  Init[3]:=Hrac3.Init;
  Init[4]:=Hrac4.Init;
  Init[5]:=Hrac5.Init;
  Init[6]:=Hrac6.Init;
  Init[7]:=Hrac7.Init;
  Tah[1]:=Hrac1.Tah;
  Tah[2]:=Hrac2.Tah;
  Tah[3]:=Hrac3.Tah;
  Tah[4]:=Hrac4.Tah;
  Tah[5]:=Hrac5.Tah;
  Tah[6]:=Hrac6.Tah;
  Tah[7]:=Hrac7.Tah;

  for i:=1 to PocHracov do
    begin
      Hraci[i].Chvost:=New(PFront);
      Max[i]:=0
    end;
  MyPalette.Size:=15;
  SetAllPalette(MyPalette);
end;

procedure ObnovNapis(Kto: integer);
const Zx = 20;
      Zy = 25;
 var w: string;
begin
  with Hraci[Poradie[Kto]] do
    begin
      Str(Dlzka-1,w);
      SetColor(Nic);
      OutTextXY(Zx+72*Poradie[Kto],Zy,w);
      if Zivy then SetColor(Poradie[Kto])
      else SetColor(Seda);
      Str(Dlzka,w);
      OutTextXY(Zx+72*Poradie[Kto],Zy,w)
    end
end;

procedure Zomrel(Hr: integer);
begin
  with Hraci[Poradie[Hr]] do
    begin
      Zivy:=false;
      inc(Mrtvych);
      ObnovNapis(Hr)
    end
end;

procedure Nakresli(x,y,Co: integer);
 var xx,yy: integer;
begin
  xx:=ZacX+x+x; yy:=ZacY+y+y;
  putpixel(xx,yy,Co);
  putpixel(xx+1,yy,Co);
  putpixel(xx,yy+1,Co);
  putpixel(xx+1,yy+1,Co)
end;

procedure InitHru;
 var i,px,py: integer;

  procedure NakresliObrazok;
    var i: integer;
  begin
    SetFillStyle(SolidFill,Nic);
    Bar(0,0,639,349);
    SetFillStyle(SolidFill,Hranica);
    Bar(ZacX,ZacY,ZacX+601,ZacY+1);
    Bar(ZacX,ZacY+300,ZacX+601,ZacY+301);
    Bar(ZacX,ZacY+1,ZacX+1,ZacY+300);
    Bar(ZacX+600,ZacY+1,ZacX+601,ZacY+300);
    SetColor(White);
    MoveTo(70,5);
    for i:=1 to PocHracov do OutText(Meno[i])
  end;

  procedure VytvorPoradie;
   var i,j,ii: integer;
  begin
    for i:=1 to PocHracov do Poradie[i]:=0;
    for i:=1 to PocHracov do
      begin
        j:=Random(PocHracov-i+1)+1;
        ii:=0;
        while j>0 do
          begin
            inc(ii);
            if Poradie[ii]=0 then dec(j);
          end;
        Poradie[ii]:=PocHracov+1-i;
      end;
  end;

begin
  for i:=1 to PocHracov do
    with Hraci[i] do
      begin
        Zivy:=true;
        Dlzka:=1;
        Cas:=ZacCas;
        PoslTah:=1;
        Chvost^.Init;
        repeat
          x:=Random(300)+1;
          y:=Random(150)+1;
          cx:=x; cy:=y;
        until (GetP(x,y)=Nic);
      end;
  NakresliObrazok;
  for i:=1 to PocHracov do
    with Hraci[i] do Nakresli(x,y,i);
  Mrtvych:=0;
  PocTahov:=0;
  ZostaloJedla:=ZacJedla;
  for i:=1 to ZacJedla do
    begin
      repeat
        px:=Random(Sirka)+1;
        py:=Random(Vyska)+1;
      until GetP(px,py)=Nic;
      Nakresli(px,py,Jedlo);
    end;
  VytvorPoradie;
  for i:=1 to PocHracov do
    begin
      Init[Poradie[i]](i);
      ObnovNapis(i)
    end;
end;

{procedure Zavrazdi;
  var c: char;
begin
  if KeyPressed then
    begin
      c:=readkey;
      if c=#0 then
        begin
          c:=Readkey;
          if c in [#59..#64] then Zomrel(Poradie[ord(c)-58])
        end;
    end;
end;}

procedure Vyhodnot;
var i: integer;
    c: char;
begin
  for i:=1 to PocHracov do if Hraci[i].Dlzka>Max[i] then Max[i]:=Hraci[i].Dlzka;
  c:=readkey;
end;

Procedure Int10; Interrupt;
  Begin
  End;

procedure VypisVysledkov;
var i,j,M: integer;
    Zn:Char;
    Score,Cislo:String[10];
    Pom10:Procedure;
Const B=150;
begin
  SetGraphMode(1);
  SetTextStyle(1,0,4);
  For I:=0 To 2 Do Begin
    Case I Of
      0:SetColor(8);
      1:SetColor(7);
      2:SetColor(15);
    End;
    OutTextXY(24-I*2+B,14-I*2,'Vysledkova listina:');
    OutTextXY(19-I*2+B,11-I*2,'  ''');
    OutTextXY(179-I*2+B,11-I*2,'''');
  End;
  for i:=1 to PocHracov do
    begin
      M:=1;
      for j:=2 to PocHracov do
        if Max[j]>Max[M] then M:=j;
      If I=1 Then SetTextStyle(1,0,6) Else SetTextStyle(1,0,4);
      Case I Of
        1:SetColor(14);
        2:SetColor(11);
        3:SetColor(12);
        Else SetColor(7);
      End;
      Str(I,Cislo);Str(Max[M],Score);
      If I=1 Then Begin
        OutTextXY(50,50,'1.');
        OutTextXY(130,50,Meno[M]);
        SetTextJustify(2,2);
        OutTextXY(600,50,Score);
        SetTextJustify(0,2);
      End Else Begin
        OutTextXY(50,I*35+35,Cislo+'.');
        OutTextXY(130,I*35+35,Meno[M]);
        SetTextJustify(2,2);
        OutTextXY(600,I*35+35,Score);
        SetTextJustify(0,2);
      End;
      Max[M]:=0
    end;
  For I:=0 To 9 Do Begin
    Case I Of
      0,1,8,9:SetColor(8);
     2,3,6,7:SetColor(7);
      4,5:SetColor(15);
    End;
    Rectangle(I,I,639-I,349-I);
  End;
  While KeyPressed Do Zn:=ReadKey;
  SwapVectors;
  GetIntVec($10,@Pom10);
  SetIntVec($10,@Int10);
  Exec('MP.COM','/a WURMI.MOD');
  SetIntVec($10,@Pom10);
  SwapVectors;
  Zn:=ReadKey;
  CloseGraph;
end;
 
begin
  InitMain;
  for Hra:=1 to PocHier do
    begin
      InitHru;
      repeat
        for Hr:=1 to PocHracov do
          with Hraci[Poradie[Hr]] do
            if Zivy then
              begin
                Cas:=Cas+CasNa1Tah;
                if Cas>0 then
                  begin
                    SetTime(0,0,0,0);
                    Tah[Poradie[Hr]](Hraci,PoslTah);
                    GetTime(h,m,s,s100);
{                    Cas:=Cas-s100-100*s-6000*m}
                  end;
                x:=x+PosX[PoslTah];
                y:=y+PosY[PoslTah];
                Chvost^.FPut(PoslTah);
                case GetP(x,y) of
                  Hranica,1,2,3,4,5,6,7: Zomrel(Hr);
                  Nic                  : begin
                                           Chvost^.FGet(Smer);
                                           Nakresli(cx,cy,Nic);
                                           cx:=cx+PosX[Smer];
                                           cy:=cy+PosY[Smer];
                                           Nakresli(x,y,Poradie[Hr])
                                         end;
                  Jedlo                : begin
                                           inc(Dlzka);
                                           ObnovNapis(Hr);
                                           Nakresli(x,y,Poradie[Hr]);
                                           dec(ZostaloJedla)
                                         end;
                end;
              end;
        inc(PocTahov);
        {Zavrazdi;}
      until ( Mrtvych=PocHracov ) or ( ZostaloJedla = 0 ) or ( PocTahov > MaxPocTahov );
      Vyhodnot
    end;
  VypisVysledkov;
end.